在不导出计划的情况下在gridview中显示计划的内容

问题描述 投票:0回答:2

问题如下: 我正在处理我的项目,现在我想将计划自动上传到我的数据库,而无需导出我的计划。用户应该只选择计划,并且应该上传其中的数据。 我已经能够将gridview / datatable中的数据上传到我的数据库。现在我需要的是一种将计划中的数据转换为gridview / datatable的方法 有没有人知道我该怎么做? api文档没有多大帮助(我正在使用C#并重新启动2018.2) 谢谢 :)

c# revit-api revit
2个回答
0
投票

The Building Coder回答了完整描述如何使用Schedule API to access schedule data的确切问题。


0
投票

是的,您可以轻松访问计划数据而无需导出。首先,获取所有计划并逐个单元地读取数据。其次,以键,值对的形式创建字典和存储数据。现在,您可以根据需要使用计划数据。我在Revit 2019中试过这个。

这是实施

public void getScheduleData(Document doc)
{
    FilteredElementCollector collector = new FilteredElementCollector(doc);
    IList<Element> collection = collector.OfClass(typeof(ViewSchedule)).ToElements();

    String prompt = "ScheduleData :";
    prompt += Environment.NewLine;

    foreach (Element e in collection)
    {
        ViewSchedule viewSchedule = e as ViewSchedule;
        TableData table = viewSchedule.GetTableData();
        TableSectionData section = table.GetSectionData(SectionType.Body);
        int nRows = section.NumberOfRows;
        int nColumns = section.NumberOfColumns;

        if (nRows > 1)
        {
            //valueData.Add(viewSchedule.Name);

            List<List<string>> scheduleData = new List<List<string>>();
            for (int i = 0; i < nRows; i++)
            {
                List<string> rowData = new List<string>();

                for (int j = 0; j < nColumns; j++)
                {
                    rowData.Add(viewSchedule.GetCellText(SectionType.Body, i, j));
                }
                scheduleData.Add(rowData);
            }

            List<string> columnData = scheduleData[0];
            scheduleData.RemoveAt(0);

            DataMapping(columnData, scheduleData);
        }
    }
}

public static void DataMapping(List<string> keyData, List<List<string>>valueData)
{
    List<Dictionary<string, string>> items= new List<Dictionary<string, string>>();

    string prompt = "Key/Value";
    prompt += Environment.NewLine;

    foreach (List<string> list in valueData)
    {
        for (int key=0, value =0 ; key< keyData.Count && value< list.Count; key++,value++)
        {
            Dictionary<string, string> newItem = new Dictionary<string, string>();

            string k = keyData[key];
            string v = list[value];
            newItem.Add(k, v);
            items.Add(newItem);
        }
    }

    foreach (Dictionary<string, string> item in items)
    {
        foreach (KeyValuePair<string, string> kvp in item)
        {
            prompt += "Key: " + kvp.Key + ",Value: " + kvp.Value;
            prompt += Environment.NewLine;
        }
    }

    Autodesk.Revit.UI.TaskDialog.Show("Revit", prompt);
}
© www.soinside.com 2019 - 2024. All rights reserved.